/*
 * MemoryZone.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include "F28335/DSP28x_Project.h"

#include <stdint.h>

#ifndef SYSCTRL_MEMORYZONE_H_
#define SYSCTRL_MEMORYZONE_H_

struct ZONE_REGISTER_16_BIT_FIELD
{
    uint16_t b0: 1;
    uint16_t b1: 1;
    uint16_t b2: 1;
    uint16_t b3: 1;
    uint16_t b4: 1;
    uint16_t b5: 1;
    uint16_t b6: 1;
    uint16_t b7: 1;
    uint16_t b8: 1;
    uint16_t b9: 1;
    uint16_t bA: 1;
    uint16_t bB: 1;
    uint16_t bC: 1;
    uint16_t bD: 1;
    uint16_t bE: 1;
    uint16_t bF: 1;
};//ZONE_REGISTER_16_BIT_FIELD


struct ZONE_REGISTER_16_BYTE_FIELD
{
    uint16_t bt0 :8;
    uint16_t bt1 :8;
};//ZONE_REGISTER_16_BYTE_FIELD

union ZONE_REGISTER_16
{
    uint16_t                u16;
    int16_t                 i16;
    ZONE_REGISTER_16_BIT_FIELD   bit;
    ZONE_REGISTER_16_BYTE_FIELD  byte;
};//REGISTER_16







#endif /* SYSCTRL_MEMORYZONE_H_ */
