/*
 * XINTF.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include "F28335/DSP28x_Project.h"

#include "DSP28335/GPIO.h"
#include "DSP28335/CPUBase.h"

#ifndef DSP28335_XINTF_H_
#define DSP28335_XINTF_H_



namespace DSP28335
{

struct XINTFSetup
{
    pGPIO_FUNCTION gpio_setup;
    XINTFSetup():
        gpio_setup(&DSP28335::GPIO::gpio_xintf_16bit_setup)
    {}
};//


class XINTF: public CPUBase
{
public:
    XINTF();
    void setup(DSP28335::XINTFSetup& setup);
private:
    void (*_gpio_setup)();
};//

} /* namespace DSP28335 */

#endif /* DSP28335_XINTF_H_ */
