/*
 * AnalogFault.cpp
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include "PERIPHERY/AnalogFault.h"

namespace PERIPHERY
{
//CONSTRUCTOR
AnalogFault::AnalogFault():
        m_fault(0),
        _gpio_analog_fault_setup(&DSP28335::GPIO::gpio_analog_fault_setup),
        _analog_fault_read(&DSP28335::GPIO::gpio_analog_fault_read)
{}//CONSTRUCTOR


void AnalogFault::setup(const AnaloFaultSetup& setup)
{
    _gpio_analog_fault_setup = setup.p_gpio_analog_fault_setup;
    _analog_fault_read = setup.p_analog_fault_read;
    //
}//
//
void AnalogFault::get_hard_code_setup(AnaloFaultSetup& hsetup)
{
    hsetup.set_default();
    //
}//
//
void AnalogFault::get_fault(uint16_t& analog_fault)
{
    (*_analog_fault_read)(m_fault);
    analog_fault = m_fault;
    //
}//
//



} /* namespace PERIPHERY */
