/*
 * IIIPeriphery.cpp
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include "PERIPHERY/IIIPeriphery.h"

namespace PERIPHERY
{
//CONSTRUCTOR
IIIPeriphery::IIIPeriphery():
        Periphery(),
        pwm_brd()
{}//CONSTRUCTOR
//
void IIIPeriphery::setup(uint16_t *memzone)
{
    p_memzone = memzone;
    dio.setup(p_memzone);
    adc.setup(p_memzone);
    dac.setup(p_memzone);
    fram.setup();
    pwm_brd.setup(p_memzone);
    //
}//
//
void IIIPeriphery::setup(uint16_t *memzone, const IIIPeripherySetup& setup)
{
    p_memzone = memzone;
    dio.setup(p_memzone);
    adc.setup(p_memzone, setup.extadc);
    dac.setup(p_memzone);
    fram.setup();
    analog_faults.setup(setup.analog_faults);
    pwm_brd.setup(p_memzone, setup.pwm_brd);
    //
}//
//
//void IIIPeriphery::configure(IIIPeripheryConfiguration& config)
//{
    //pwm_brd.configure(config.pwm_brd);
    //
//}//


void IIIPeriphery::get_hard_code_setup(IIIPeripherySetup& hsetup)
{
    hsetup.pwm_brd.set_default();
    hsetup.extadc.set_default();
    hsetup.analog_faults.set_default();
    //
}//
//

} /* namespace PERIPHERY */
