/*
 * PeripheryMap.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */

#include <math.h>
#include <stdint.h>

#ifndef PERIPHERY_PERIPHERYMAP_H_
#define PERIPHERY_PERIPHERYMAP_H_

#define OFFSET_PWM_PHASE_A       ((uint16_t)0x0100)
#define OFFSET_PWM_PHASE_B       ((uint16_t)0x0200)
#define OFFSET_PWM_PHASE_C       ((uint16_t)0x0300)
#define OFFSET_PWM_PHASE         OFFSET_PWM_PHASE_C

#define OFFSET_BROADCAST_FREQ    ((uint16_t)0x0490)
#define OFFSET_BROADCAST_CELLNUMBER     ((uint16_t)0x0491)
#define OFFSET_BROADCAST_ORDER   ((uint16_t)0x0493)

#define OFFSET_FREQ_PWM          ((uint16_t)0x0090)
#define OFFSET_CQ_IN_PHASE       ((uint16_t)0x0091)
#define OFFSET_CMP               ((uint16_t)0x0092)
#define OFFSET_ORDER             ((uint16_t)0x0093)
#define OFFSET_PWM_STATE         ((uint16_t)0x0094)
#define OFFSET_PWM_VERSION       ((uint16_t)0x0095)
#define OFFSET_CQ_IN_CASC_00     ((uint16_t)0x0096)
#define OFFSET_CQ_IN_CASC_01     ((uint16_t)0x0097)
#define OFFSET_CQ_IN_CASC_02     ((uint16_t)0x0098)
#define OFFSET_CQ_IN_CASC_03     ((uint16_t)0x0099)
#define OFFSET_CQ_IN_CASC_04     ((uint16_t)0x009A)
#define OFFSET_CQ_IN_CASC_05     ((uint16_t)0x009B)
#define OFFSET_CQ_IN_CASC_06     ((uint16_t)0x009C)
#define OFFSET_CQ_IN_CASC_07     ((uint16_t)0x009D)
#define OFFSET_CQ_IN_CASC_08     ((uint16_t)0x009E)
#define OFFSET_CQ_IN_CASC_09     ((uint16_t)0x009F)
#define OFFSET_CQ_IN_CASC_10     ((uint16_t)0x00A0)
#define OFFSET_CQ_IN_CASC_11     ((uint16_t)0x00A1)
#define OFFSET_CQ_IN_CASC_12     ((uint16_t)0x00A2)
#define OFFSET_CQ_IN_CASC_13     ((uint16_t)0x00A3)
#define OFFSET_CQ_IN_CASC_14     ((uint16_t)0x00A4)
#define OFFSET_CQ_IN_CASC_15     ((uint16_t)0x00A5)
#define OFFSET_CQ_IN_CASC_16     ((uint16_t)0x00A6)
#define OFFSET_CQ_IN_CASC_17     ((uint16_t)0x00A7)
#define OFFSET_CELL_BREAKDOWN    ((uint16_t)0x00A8)
#define OFFSET_CELL_BREAKDOWN_ADR ((uint16_t)0x00A9)

#define OFFSET_TELEMETRY         ((uint16_t)0x00FF)

#define OFFSET_CASCADE_00        ((uint16_t)0x0000)
#define OFFSET_CASCADE_01        ((uint16_t)0x0008)
#define OFFSET_CASCADE_02        ((uint16_t)0x0010)
#define OFFSET_CASCADE_03        ((uint16_t)0x0018)
#define OFFSET_CASCADE_04        ((uint16_t)0x0020)
#define OFFSET_CASCADE_05        ((uint16_t)0x0028)
#define OFFSET_CASCADE_06        ((uint16_t)0x0030)
#define OFFSET_CASCADE_07        ((uint16_t)0x0038)
#define OFFSET_CASCADE_08        ((uint16_t)0x0040)
#define OFFSET_CASCADE_09        ((uint16_t)0x0048)
#define OFFSET_CASCADE_10        ((uint16_t)0x0050)
#define OFFSET_CASCADE_11        ((uint16_t)0x0058)
#define OFFSET_CASCADE_12        ((uint16_t)0x0060)
#define OFFSET_CASCADE_13        ((uint16_t)0x0068)
#define OFFSET_CASCADE_14        ((uint16_t)0x0070)
#define OFFSET_CASCADE_15        ((uint16_t)0x0078)
#define OFFSET_CASCADE_16        ((uint16_t)0x0080)
#define OFFSET_CASCADE_17        ((uint16_t)0x0088)

#define OFFSET_DATA_DISCRETE_IO  ((uint16_t)0x0900)

#define OFFSET_DAC_CHANNEL_A    ((uint16_t)0x0800)
#define OFFSET_DAC_CHANNEL_B    ((uint16_t)0x0801)
#define OFFSET_DAC_CHANNEL_C    ((uint16_t)0x0802)
#define OFFSET_DAC_CHANNEL_D    ((uint16_t)0x0803)

#define OFFSET_ADC_0_CHANNEL_0  ((uint16_t)0x0D00)
#define OFFSET_ADC_0_CHANNEL_1  ((uint16_t)0x0D01)
#define OFFSET_ADC_0_CHANNEL_2  ((uint16_t)0x0D02)
#define OFFSET_ADC_0_CHANNEL_3  ((uint16_t)0x0D03)
#define OFFSET_ADC_0_CHANNEL_4  ((uint16_t)0x0D04)
#define OFFSET_ADC_0_CHANNEL_5  ((uint16_t)0x0D05)

#define OFFSET_ADC_1_CHANNEL_0  ((uint16_t)0x0E05)
#define OFFSET_ADC_1_CHANNEL_1  ((uint16_t)0x0E06)
#define OFFSET_ADC_1_CHANNEL_2  ((uint16_t)0x0E07)
#define OFFSET_ADC_1_CHANNEL_3  ((uint16_t)0x0E08)
#define OFFSET_ADC_1_CHANNEL_4  ((uint16_t)0x0E09)
#define OFFSET_ADC_1_CHANNEL_5  ((uint16_t)0x0E0A)

#define OFFSET_ADC_2_CHANNEL_0  ((uint16_t)0x0F0A)
#define OFFSET_ADC_2_CHANNEL_1  ((uint16_t)0x0F0B)
#define OFFSET_ADC_2_CHANNEL_2  ((uint16_t)0x0F0C)
#define OFFSET_ADC_2_CHANNEL_3  ((uint16_t)0x0F0D)
#define OFFSET_ADC_2_CHANNEL_4  ((uint16_t)0x0F0E)
#define OFFSET_ADC_2_CHANNEL_5  ((uint16_t)0x0F0F)






#endif /* PERIPHERY_PERIPHERYMAP_H_ */
